/*globals define*/
/*jslint nomen:true*/

define([
    'jquery',
    'testsuite/qunit',
    'de_epages/shop/linkpicker/externalurlview',

    '$ready!'
], function ($, QUnit, Externalurlview) {
    'use strict';

    var container = $('#qunit-fixture'),
        data = {},
        externalurlview = new Externalurlview(),
        view = externalurlview.render().$el;

    QUnit.module("de_epages/shop/linkpicker/externalurlview");

    QUnit.test("Linkpicker-additionalpages Prototype", function () {

        $.each([
            'render',
            'clearLinkData',
            'setUrl',
            '_publishLinkUrl'], function (i, fn) {

            QUnit.deepEqual($.isFunction(externalurlview[fn]), true, "Check whether " + fn + " is a function: $.isFunction( addidtionalpagesview.prototype['" + fn + "'] )");
        });
    });

    QUnit.test("Rendered Template and UI", function () {

        container.empty().append(view);
        QUnit.strictEqual(container.html(), '<div>' + view.html() + '</div>', 'Template is rendered correctly');

        externalurlview.setUrl('www.google.de');
        QUnit.strictEqual($('#ep-linkpicker-externalUrl').val(), 'www.google.de', 'external url is set correctly');

        externalurlview.on('linkurlchanged', function (_url) {
            QUnit.strictEqual(_url, 'www.google.de', 'External url is fetched correctly');
        });
        $('#ep-linkpicker-externalUrl').trigger('keyup');

        externalurlview.clearLinkData();
        QUnit.strictEqual($('#ep-linkpicker-externalUrl').val(), '', 'external url is unset correctly');
    });
});