/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource['epages.cartridges.de_epages.presentation.objectupdater']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.objectupdater'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.browser

*/
dojo.provide('epages.cartridges.de_epages.presentation.objectupdater');
dojo.require('epages.lang.array');
dojo.require('epages.lang.hash');
dojo.require('epages.lang.uri');
dojo.require('epages.io.json');

epages.cartridges.de_epages.presentation.ObjectUpdater = new epages.Class();
epages.cartridges.de_epages.presentation.ObjectUpdater.prototype = {
	siteId:       epages.vars.SiteID,
	initialize: function (options) {
		if (options !== undefined){
			dojo.mixin(this,options);
		}

		var tmpFunc = function() {
			var body = dojo.body();
			var stateHint = document.createElement("div");
			stateHint.appendChild(document.createTextNode('Loading...'));
			//dojo.addClass(stateHint, 'epagesObjectupdaterStateHint');
			stateHint.setAttribute('id', 'epagesObjectupdaterStateHint');
			stateHint.style.position = "absolute";
			stateHint.style.backgroundColor="red";
			stateHint.style.color = "white";
			stateHint.style.left = "150px";
			stateHint.style.top = "0px";
			stateHint.style.width = "150px";
			stateHint.style.height = "18px";
			stateHint.style.zIndex = "255";
			stateHint.style.display = "none";
			body.appendChild(stateHint);
		};

		if (dojo.body()) {
			if (!document.getElementById('epagesObjectupdaterStateHint')) {
				tmpFunc();
			}
		} else {
			dojo.addOnLoad(tmpFunc);
		}
	},

	getFormDataViaArray: function(/*ArrayLike*/data) {
	// depricated - will be removed in the next version
		var formData = [];
		$A(data).each( function(el) {
			formData.push($H(el).toQueryString());
		});
		return formData.join('&');
	},

	getFormDataViaHash: function(/*String*/guid, /*epages.lang.Hash||Object*/data) {
	  //alert("getFormDataViaHash is still in use!")
	  //used inside external content google map
		var formData = {
		  'GUID': [],
		  'Name': [],
		  'Value': []
		};
		$A($H(data).keys()).each( function(key) {
		  formData.GUID.push(guid);
		  formData.Name.push(key);
		  formData.Value.push(data[key]);
		});
		return formData;
	},

	getFormDataViaObjectForm: function(/*ObjectLike*/data) {
		var formData = {
		  'GUID': [],
		  'Name': [],
		  'Value': [],
		  'LocalizedGUID': [],
		  'LocalizedName': [],
		  'LocalizedValue': [],
		  'LanguageID': [],
		  'DeleteGUID': []
		};
		$H(data).each( function(el) {
			var hElement = el.key;
			var names = el.key.split(':');
			if (el.value == 'Delete')  {
			  formData.DeleteGUID.push(names[0]);
			} else if (names.length == 2) {
	  		  formData.GUID.push(names[0]);
	  		  formData.Name.push(names[1]);
	  		  // EPG-23763: Set value to '' if undefined
	  		  formData.Value.push(el.value ? el.value : '');
			} else if (names.length == 3) {
	  		  formData.LocalizedGUID.push(names[0]);
	  		  formData.LocalizedName.push(names[1]);
	  		  formData.LocalizedValue.push(el.value);
	  		  formData.LanguageID.push(names[2]);
			}
		});
		return formData;
	},

	sendAsync: function(/*String*/url, /*Object?*/formData, /*function?*/callback,isWizard/*boolean*/) {
		if (formData == ''){
			return;
		}
		var params = {
			ViewAction:   'JSONViewResponse',
			ObjectID:     this.siteId,
			ChangeAction: 'SaveGUIDList'
		};
		if(isWizard){
			params.IsWizard = true;
		}
		if (formData != null){
			dojo.mixin(params, formData);
		}
		var jsonIo = new epages.io.Json();
		jsonIo.loadAsync(url, callback, params, epages.io.json.defaultErrorCallback);
	}

};

}
