/*globals require, window*/

require([
    'jquery',
    'ep',
    'testsuite/qunit',
    'de_epages/shop/inc/jwt-tools',
    // 'testsuite/qunit-fixture!de_epages/shop/inc/jwt-tools-test',
], function ($, ep, QUnit, jwt/*, fixture*/) {
    'use strict';

    ep.ajax = function (o) {
        var result = $.Deferred();
        if (o.data && o.data.ChangeAction === 'JSONCreateJWT') {
            result.resolveWith(result, [{
                "token": "0815",
                "data": o.data
            }]);
        }
        return result;
    };

    QUnit.module("de_epages/shop/inc/jwt-tools");

    QUnit.asyncTest("JSON Web Token (jwt) Prototype", function () {

        $.each([
            'requestToken'
        ], function (i, fn) {
            QUnit.equal(
                $.isFunction(jwt[fn]),
                true,
                '$.isFunction(' + fn + '):'
            );
        });

        QUnit.start();
    });

    QUnit.asyncTest('de_epages/shop/ui/dashboard', function () {
        jwt.requestToken({
            url: 'abc.de',
            ViewAction: 'JSONViewResponse',
            ChangeAction: 'JSONCreateJWT',
            ChangeObjectID: 4711
        },
        function(data) {
            QUnit.equal(data.data.ChangeAction, 'JSONCreateJWT', 'ChangeAction was ' + data.data.ChangeAction);
            QUnit.equal(data.data.ViewAction, 'JSONViewResponse', 'ViewAction was ' + data.data.ViewAction);
            QUnit.equal(data.data.ChangeObjectID, 4711, 'ChangeObjectID was ' + data.data.ChangeObjectID);
            QUnit.equal(data.token, '0815', 'Received token is ' + data.token);
        });

        QUnit.start();
    });
});